class RecetasController < ApplicationController
	
	helper RecetasHelper
	require 'will_paginate/array'

	def index

		case params[:filtro]
		when nil
			@recetas = Receta.paginate(:page => params[:page], :per_page => 9).order("created_at DESC")
		when "filtrar"
			if ((params[:dificultad_1] == 'dificultad_1' && params[:dificultad_2] == 'dificultad_2' && params[:dificultad_3] == 'dificultad_3') ||
				(params[:dificultad_1] == '' && params[:dificultad_2] == '' && params[:dificultad_3] == ''))
				all_recetas = Receta.all
			elsif ((params[:dificultad_1] == 'dificultad_1' && params[:dificultad_2] == 'dificultad_2') || 
					(params[:dificultad_1] == 'dificultad_1' && params[:dificultad_2] == 'dificultad_3') ||
						(params[:dificultad_1] == 'dificultad_3' && params[:dificultad_2] == 'dificultad_2'))
			
				if params[:dificultad_1] == ''
					all_recetas = Receta.where.not(dificultad: "1")
				elsif params[:dificultad_2] == ''
					all_recetas = Receta.where.not(dificultad: "2")
				else
					all_recetas = Receta.where.not(dificultad: "3")
				end
					
			else
				if params[:dificultad_1] == 'dificultad_1'
					all_recetas = Receta.where("dificultad = ?", 1)
				elsif params[:dificultad_2] == 'dificultad_2'
					all_recetas = Receta.where("dificultad = ?", 2)
				else
					all_recetas = Receta.where("dificultad = ?", 3) 
				end
			end
					
					
			recetas_filtradas = Array.new
			all_recetas.each do |receta|
				if ((params[:min_kcal].to_i..params[:max_kcal].to_i).include?(receta.kcal_racion))
					recetas_filtradas.push(receta)
				end
			end
 			recetas_kcal = recetas_filtradas.dup
			recetas_kcal.each do |receta|
				if !((params[:min_tiempo].to_i..params[:max_tiempo].to_i).include?(receta.tiempo))
					recetas_filtradas.delete(receta)
				end
			end

	
			
			if params[:sin_gluten] == "sin_gluten"
				recetas_gluten = recetas_filtradas.dup
				recetas_gluten.each do |receta|
					if receta.gluten
						recetas_filtradas.delete(receta)
					end
				end
				
			end

			if params[:vegetariano]== "vegetariano"
				recetas_vegetarianas = recetas_filtradas.dup
				recetas_vegetarianas.each do |receta|
					if !receta.vegetariano || !receta.vegano
						recetas_filtradas.delete(receta)
					end
				end
				
			end

			@recetas = recetas_filtradas.paginate(:page => params[:page], :per_page => 9)
		end
	end


	def search_by_ingredient
		@alimento = Alimento.find_by(nombre: params[:alimento])
		if @alimento.nil?
			@recetas = Array.new
			render 'index'
		elsif @alimento.recetas.empty?
			@recetas = @alimento.recetas.paginate(:page => params[:page], :per_page => 9)
			render 'index'
		else 	
			@recetas = @alimento.recetas.paginate(:page => params[:page], :per_page => 9)
			render 'index'
		end
	end

	def show
		@receta = Receta.find(params[:id])
	end

	def new
		@receta = Receta.new
		1.times{@receta.ingredientes.build}
		1.times{@receta.pasos.build}
	end

	def create
		@receta = Receta.create(receta_params)
		if !@receta.valid?
			render 'new'
		else
			render 'show', :locals => { :receta => @receta }
		end
	end


	def create_ingredients
		alimento = Alimento.find_by(nombre: params[:alimento])
		@ingrediente = Ingrediente.new(alimento_id: alimento.id, cantidad: params[:cantidad])
		@ingredientes = Array.new
		@ingredientes.push(@ingrediente)
		if @ingrediente.valid?
			render 'new_ingredients'
		else
			@receta = session[:receta]
			render html: "#{@receta.class.superclass}"
			#@receta.ingredientes = @ingredientes
			#render 'show'
		end

	
	end


	def search
		@receta = Receta.find_by(nombre: params[:receta])
		if @receta.nil?
			@busqueda = 'La Receta'
			render 'shared/not_exist_error', :locals => { :busqueda => @busqueda }
		else
			render 'show'
		end
	end

	private
    # Using a private method to encapsulate the permissible parameters
    # is just a good pattern since you'll be able to reuse the same
    # permit list between create and update. Also, you can specialize
    # this method with per-user checking of permissible attributes.
    def receta_params
      params.require(:receta).permit(:nombre, :descripcion, :foto, :dificultad, :raciones, :tiempo,pasos_attributes: [:id, :numero_paso, :receta_id, :descripcion, :_destroy],
      			ingredientes_attributes: [:id, :alimento_id, :receta_id,:cantidad, :_destroy])
    end
end
